class Candidate extends Element {
    var name, position, color, pending_update, active, dragging, moved;
    var line, handle, line_color, clip_color;

    static var HIGHLIGHTED = {aa: 200};
    static var NORMAL = {aa: 100};
    static var HIDDEN = {aa: 0};
    
    function Candidate(parent, name, position, color, length, size) {
        init(parent);
        this.name = name;
        this.position = position;
        this.color = color;
        this.pending_update = false;
        this.active = true;
        this.dragging = false;
        this.moved = false;
        
        // handle drop shadow
        /*
        clip.lineStyle(1, RGB.grey(0.9), 50);
        clip.moveTo(2.5, 3+length);
        clip.lineTo(3+size, 3+length + size*2);
        clip.lineTo(-size, 3+length + size*2);
        clip.lineTo(1-size, length + size*2);

        clip.lineStyle(1, RGB.grey(0.75), 50);
        clip.moveTo(1.5, 2+length);
        clip.lineTo(2+size, 2+length + size*2);
        clip.lineTo(1-size, 2+length + size*2);
        clip.lineTo(1-size, length + size*2);

        clip.lineStyle(1, RGB.grey(0.55), 50);
        clip.moveTo(0.5, 1+length);
        clip.lineTo(1+size, 1+length + size*2);
        clip.lineTo(1-size, 1+length + size*2);
        */

        // indicator line and highlight
        line = new Element(this);
        line.clip.lineStyle(6, RGB.white, 30);
        line.clip.moveTo(-0.5, 0);
        line.clip.lineTo(-0.5, length);
        line.clip.lineTo(-0.5, 0);
        line.clip.lineStyle(2, RGB.multiply(color, 0.5), 70);
        line.clip.moveTo(-0.5, 0);
        line.clip.lineTo(-0.5, length);

        // indicator handle
        handle = new Element(this);
        handle.clip.lineStyle(2, RGB.multiply(color, 0.5), 70);
        handle.clip.beginFill(color, 50);
        handle.clip.moveTo(0, length);
        handle.clip.lineTo(-size, length + size*2);
        handle.clip.lineTo(size, length + size*2);
        handle.clip.lineTo(0, length);
        handle.clip.endFill();
        handle.clip.useHandCursor = true;
        
        var candidate = this;
        line_color = new Color(line.clip);
        clip_color = new Color(clip);
        clip.onRollOver = function() {
            this.swapDepths(parent.clip.getNextHighestDepth());
            candidate.clip_color.setTransform(Candidate.HIGHLIGHTED);
        }
        clip.onRollOut = function() {
            candidate.clip_color.setTransform(Candidate.NORMAL);
        }
        clip.onPress = function() {
            this.startDrag(false, 0, 0, parent.width, 0);
            candidate.dragging = true;
            candidate.moved = false;
        }
        clip.onMouseMove = function() {
            if (candidate.dragging) {
                candidate.moved = true;
                if (candidate.active) candidate.pending_update = true;
            }
        }
        clip.onRelease = function() {
            this.stopDrag();
            candidate.dragging = false;
            if (candidate.moved) {
                if (candidate.active) candidate.pending_update = true;
            } else {
                candidate.set_active(!candidate.active);
            }
        }
        clip.onReleaseOutside = function() {
            this.clip.onRelease();
            candidate.clip_color.setTransform(Candidate.NORMAL);
        }
    }

    function set_active(active) {
        this.active = active;
        line_color.setTransform(active ? NORMAL : HIDDEN);
        pending_update = true;
    }
}
