class Main extends Element {
    var slider_panel, voter_panel, blend_panel, explanation_panel;
    var d;
    static var distributions = [
        Distributions.Normal, Distributions.Bimodal, Distributions.Uniform];

    function Main(clip) {
        this.clip = clip;
        var methods = [Methods.Plurality,
                       Methods.Approval,
                       Methods.Borda,
                       Methods.Condorcet,
                       Methods.Hare];
        d = 0;
        slider_panel = new SliderPanel(
            this, 3, 800, 28, 15, methods, distributions[d]);
        voter_panel = new VoterPanel(
            this, 3, 800, 360, distributions[d]);

        voter_panel.clip._y = -15;
        slider_panel.clip._y = 360;
        slider_panel.add_candidate('red', -1.5, RGB.red, true);
        slider_panel.add_candidate(
            'green', 0.7, RGB.multiply(RGB.green, 0.8), true);
        slider_panel.add_candidate('orange', 3, RGB.orange,false);
        slider_panel.add_candidate('blue', 3, RGB.blue, false);
        slider_panel.add_candidate(
            'yellow', 3, RGB.multiply(RGB.yellow, 0.9), false);

        blend_panel = new BlendPanel(
            this, slider_panel.all_candidates, 800, 260);
        blend_panel.clip._y = 85;

        explanation_panel = new ExplanationPanel(this);
    }

    function change_distribution() {
        d = (d + 1) % distributions.length;
        slider_panel.set_distribution(distributions[d]);
        voter_panel.set_distribution(distributions[d]);
    }

    function benchmark() {
        var start = getTimer();
        var trials = 10;
        for (var i = 0; i < trials; i++) {
            slider_panel.elect();
        }
        var finish = getTimer();
        Debug.write(Math.round((finish - start)/trials), "ms");
    }
    
    static function main() {
        Stage.scaleMode = "noScale";
        var main = new Main(_root);
    }
}
